unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    function GetWindowHandle(const ClassName, WindowTitle: string): HWND;
    procedure SendData(const ClassName, WindowTitle, Str: string);
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  StrUtils;

procedure TForm1.Button1Click(Sender: TObject);
begin
  SendData(Edit1.Text, Edit2.Text, Memo1.Lines.Text);
end;



function TForm1.GetWindowHandle(const ClassName, WindowTitle: string): HWND;
var
  wHandle: Hwnd;
  CClassName: array[0..255] of Char;
  CWindowTitle: array[0..255] of Char;

begin
  Result := 0;
  wHandle := GetWindow(Application.Handle, GW_HWNDFIRST);

  repeat
    GetClassName(wHandle, CClassName, 255);

    if (ClassName = '') or AnsiContainsText(string(CClassName), ClassName) then
    begin
      GetWindowText(wHandle, CWindowTitle, 255);

      if (WindowTitle = '') or AnsiContainsText(string(CWindowTitle), WindowTitle) then
      begin
        Result := wHandle;
      end;
    end;

    wHandle := GetWindow(wHandle, GW_HWNDNEXT);
  until (wHandle <= 0) or (Result > 0);
end;



procedure TForm1.SendData(const ClassName, WindowTitle, Str: string);
var
  MyHandle: HWND;
  aCopyData: TCopyDataStruct;
  p: PChar;

begin
  MyHandle := GetWindowHandle(ClassName, WindowTitle);

  if MyHandle > 0 then
  begin
    p := PChar(Str);

    with aCopyData do
    begin
      dwData := 0;
      cbData := StrLen(p) + 1;
      lpData := p;
    end;

    SetForegroundWindow(MyHandle); // TODO: Fenster immer aktivieren?
    SendMessage(MyHandle, WM_COPYDATA, Longint(Handle), Longint(@aCopyData));
  end;
end;



end.
